package com.tzld.piaoquan.recommend.server.service.rank;

import com.aliyun.odps.utils.StringUtils;
import com.tzld.piaoquan.recommend.server.service.rank.strategy.*;
import com.tzld.piaoquan.recommend.server.util.JSONUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
@Slf4j
public class RankRouter {
    @Autowired
    private RankService rankService;
    @Autowired
    private RankStrategy4Rankv2Model rankStrategy4Rankv2Model;
    @Autowired
    private RankStrategy4RankModel rankStrategy4RankModel;
    @Autowired
    private RankStrategy4Density rankStrategy4Density;
    @Autowired
    private RankStrategy4RegionMergeModelV536 rankStrategy4RegionMergeModelV536;
    @Autowired
    private RankStrategy4RegionMergeModelV2 rankStrategy4RegionMergeModelV2;
    @Autowired
    private RankStrategy4RegionMergeModelV3 rankStrategy4RegionMergeModelV3;
    @Autowired
    private RankStrategy4RegionMergeModelV4 rankStrategy4RegionMergeModelV4;
    @Autowired
    private RankStrategy4RegionMergeModelV547 rankStrategy4RegionMergeModelV547;
    @Autowired
    private RankStrategy4RegionMergeModelV548 rankStrategy4RegionMergeModelV548;
    @Autowired
    private RankStrategy4RegionMergeModelV561 rankStrategy4RegionMergeModelV561;
    @Autowired
    private RankStrategy4RegionMergeModelV562 rankStrategy4RegionMergeModelV562;
    @Autowired
    private FestivalStrategy4RankModel festivalStrategy4RankModel;

    @Autowired
    private RankStrategyFlowThompsonModel rankStrategyFlowThompsonModel;
    @Autowired
    private RankStrategy4RegionMerge rankStrategy4RegionMerge;

    public RankResult rank(RankParam param) {
        String abCode = param.getAbCode();
        if (StringUtils.isBlank(abCode)) {
            return rankService.rank(param);
        }
        switch (abCode) {
            case "60097":
                return rankStrategy4Density.rank(param);
            case "60106":
                return rankStrategy4Rankv2Model.rank(param);
            case "60101":
                return rankStrategy4RankModel.rank(param);
            case "60098":
            case "60111": // 561
                return rankStrategy4RegionMergeModelV561.rank(param);
            case "60112": // 562
                return rankStrategy4RegionMergeModelV562.rank(param);
            case "60113":
            case "60114":
            case "60115":
            case "60116":
            case "60117":
            case "60118":
            case "60107": // 556
                return rankStrategyFlowThompsonModel.rank(param);
            case "60120": // 576
                return rankStrategy4RegionMerge.rank(param);
            case "60121": // 536
                return rankStrategy4RegionMergeModelV536.rank(param);
            case "60122": // 537
                return rankStrategy4RegionMergeModelV2.rank(param);
            case "60123": // 541
                return rankStrategy4RegionMergeModelV3.rank(param);
            case "60124": // 546
                return rankStrategy4RegionMergeModelV2.rank(param);
            case "60125": // 547
                return rankStrategy4RegionMergeModelV547.rank(param);
            case "60126": // 548
                return rankStrategy4RegionMergeModelV548.rank(param);
            case "60130":
            case "60131":
            case "60132":
                return festivalStrategy4RankModel.rank(param);
            default:
                break;
        }
        return rankService.rank(param);
    }
}

